<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <div class="catalog-page">

        <div style="height: 40px;"></div>

        <div>
            <div class="datatable artifact-table">
                <div class="datatable-body">

                    <div class="datatable-body-row">
                        <div class="datatable-body-row-preview">
                            <div class="artifact-details-table no-line">

                                <div class="kpi">
                                    <div v-for="(quality, index) in filteredQualityMeasurements()" :key="index">
                                        <h3>{{ quality.metric && quality.metric.includes('.') ? quality.metric.split('.')[1].replace(/_/g, ' ') : quality.metric.replace(/_/g, ' ') }}</h3>
                                        <p><span>{{ isNaN(quality.value) ? quality.value : parseFloat(quality.value).toFixed(2)}}</span></p>
                                    </div>
                                </div>

                            </div>
                        </div>
                    </div>

                    <div class="datatable-body-row" v-if="filteredQualityMeasurementsNumeric().length > 0">
                        <div class="datatable-body-row-preview">
                            <div class="datatable-body-title">
                                Inherent KPIs
                            </div>
                            <div class="artifact-details-table">
                                <div class="line line-kpi" v-for="(numeric, index) in filteredQualityMeasurementsNumeric()" :key="index">
                                    <div>{{ numeric.metric && numeric.metric.includes('.') ? numeric.metric.split('.')[1].replace(/_/g, ' ') : numeric.metric.replace(/_/g, ' ') }}</div>
                                    <div>{{ isNaN(numeric.value) ? numeric.value : parseFloat(numeric.value).toFixed(2)}}</div>
                                </div>

                            </div>
                        </div>
                    </div>

                    <div class="datatable-body-row" v-if="filteredQualityMeasurementsOthers().length > 0">
                        <div class="datatable-body-row-preview">
                            <div class="datatable-body-title">
                                User Defined Rules
                            </div>
                            <div class="artifact-details-table">
                                <div class="line line-kpi" v-for="(others, index) in filteredQualityMeasurementsOthers()" :key="index">
                                    <div>{{ others.metric && others.metric.includes('.') ? others.metric.split('.')[1].replace(/_/g, ' ') : others.metric.replace(/_/g, ' ')}}</div>
                                    <div>{{ isNaN(others.value) ? others.value : parseFloat(others.value).toFixed(2)}}</div>
                                </div>

                            </div>
                        </div>
                    </div>

                    <div class="datatable-body-row">
                        <div class="datatable-body-row-preview">
                            <div class="artifact-details-table no-line">
                                <img src="assets/images/graphic.png" alt="">
                            </div>
                        </div>
                    </div>

                </div>
            </div>
        </div>

    </div>
</template>
<script setup lang="ts">
import type DataTableI from '~/interfaces/datatable';
import { ref } from 'vue';
import { useRoute } from 'vue-router';

const route = useRoute();

const columnDetails = ref<any>(null);

// get artifacts detail
async function fetchData() {
  if (route.params.id) {
    try {
		const response = await useFetchAuth(`/columns/${route.params.id}`) as { columns: any[] };
		columnDetails.value = response || {};
		
    } catch (error) {
      console.error('Error fetching data:', error);
      columnDetails.value = {}; 
    }
  }
}

onMounted(() => {
  fetchData();
});

watch(() => route.params.id, () => {
  fetchData();
}, { immediate: true });

useHead({
    title: 'Catalog - DATAMITE'
});

const showCreateDatasetModal = ref(false);

const close = () => {
    showCreateDatasetModal.value = false;
};

// make the function close available to emit in other components
defineExpose({ close });


// filter general quality measurements
const filteredQualityMeasurements = () => {
    if (!columnDetails.value || !columnDetails.value.qualityMeasurements) {
        return []; // Return an empty array if data is not available
    }

    return columnDetails.value.qualityMeasurements.filter(
        (quality: any) => quality.metric.startsWith('general.')
    );
}

// filter numeric quality measurements and hide histogram and box_plot
const filteredQualityMeasurementsNumeric = () => {
    // Filter out 'histogram' and 'box_plot' before rendering
    if (!columnDetails.value || !columnDetails.value.qualityMeasurements) {
        return []; // Return an empty array if data is not available
    }

    return columnDetails.value.qualityMeasurements.filter(
        (quality: any) => quality.metric.startsWith('numeric.') && quality.metric !== 'numeric.histogram' && quality.metric !== 'numeric.box_plot'
    );
}

const filteredQualityMeasurementsOthers = () => {
  // Check if columnDetails and qualityMeasurements exist before trying to filter
  if (!columnDetails.value || !columnDetails.value.qualityMeasurements) {
    return []; // Return an empty array if data is not available
  }

  // Filter out metrics that are not 'general.*' or 'numeric.*'
  return columnDetails.value.qualityMeasurements.filter(
    (quality: any) => 
      !quality.metric.startsWith('general.') && 
      !quality.metric.startsWith('numeric.') &&
      !quality.value.startsWith('[')
  );
};

console.log(1,filteredQualityMeasurementsOthers())
</script>